
/* Dietmars selbstgemachte Zahl-to-string Routinen */

typedef unsigned char byte;

//-----------------------------------------------------------------------------

char * stoa(char *buffer, const char  * txt){
  while ((*buffer++ = *txt++));
  return buffer-1;
}


//-----------------------------------------------------------------------------
//Druckt Zahl mit anhaengendem Text in Puffer
//Zahl wird rechtsbuendig mit <len> Stellen ausgegeben und mit Spaces aufgefuellt
//Ist die Zahl zu lang, werden len "#" ausgegeben
//Negativen Zahlen wird ein "-" vorangestellt
//Liefert Zeiger auf den abschliessenden '\0'.

//Dieses Macro dient zum definieren der Funktion fuer verschiedenen Integer-Datentypen
#define INT_STR2STR(name, vartyp) char * name(char * buffer, vartyp val, int len, const char  * txt ){ \
  char neg; \
  int i; \
    if (len<1) return buffer; \
    if (val < 0){ \
      val=0-val; \
      neg=1; \
    }else{ \
      neg=0; \
    }   \
    i=len; \
    do{ \
      buffer[--i] = (val % 10) + '0'; \
      val /= 10; \
    }while (val && (i>neg)); \
    if (val){ \
      for (i=0; i<len; buffer[i++] = '#'); \
      i=0;\
    }\
    if (i && neg){ \
      buffer[--i] = '-'; \
    } \
    while (i){ \
      buffer[--i] = ' '; \
    } \
    buffer+=len;   \
    while ((*buffer++=*txt++)); \
    return buffer-1; \
  } 
  
//Druckt Zahl mit anhaengendem Text in Puffer
//Zahl wird rechtsbuendig mit <len> Stellen ausgegeben und mit 0 aufgefuellt
//Ist die Zahl zu lang, werden len "#" ausgegeben
//Negativen Zahlen wird ein "-" vorangestellt
//Liefert Zeiger auf den abschliessenden '\0'.

//Dieses Macro dient zum definieren der Funktion fuer verschiedenen Integer-Datentypen
#define INT_STR2STR0(name, vartyp) char * name(char * buffer, vartyp val, int len, const char  * txt ){ \
  char neg; \
  int i; \
    if (len<1) return buffer; \
    if (val < 0){ \
      val=0-val; \
      neg=1; \
    }else{ \
      neg=0; \
    }   \
    i=len; \
    do{ \
      buffer[--i] = (val % 10) + '0'; \
      val /= 10; \
    }while (val && (i>neg)); \
    if (val){ \
      for (i=0; i<len; buffer[i++] = '#'); \
      i=0;\
    }\
    while (i>neg){ \
      buffer[--i] = '0'; \
    } \
    if (neg){ \
      buffer[--i] = '-'; \
    } \
    buffer+=len;   \
    while ((*buffer++=*txt++)); \
    return buffer-1; \
  } 
  


//(int val, int len, char * txt, char * buffer)
INT_STR2STR(isTOa,int);
INT_STR2STR0(isTOa0,int);
INT_STR2STR(uisTOa,unsigned int);
INT_STR2STR0(uisTOa0,unsigned int);
INT_STR2STR(lsTOa,long);
INT_STR2STR(ulsTOa,unsigned long);

